unit WizardUnit;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ExtCtrls, FileCtrl, URLLabelUnit, MemoComponentUnit;

const
	WelcomePage = 0;
	LicensePage = WelcomePage + 1;
	HTMLHelpDownloadPage = LicensePage + 1;
	InstallAppsPage = HTMLHelpDownloadPage + 1;
	InstallNonFreePage = InstallAppsPage + 1;
	FolderSelectionPage = InstallNonFreePage + 1;
	StartMenuFolderPage = FolderSelectionPage + 1;
	PathLinePage = StartMenuFolderPage + 1;
	RegPathLinePage = PathLinePage + 1;
	ReviseSettingsPage = RegPathLinePage + 1;

type
	TWizardForm = class(TForm)
		Bevel1: TBevel;
		ImagePanel: TPanel;
		BackButton: TButton;
		NextButton: TButton;
		CancelButton: TButton;
		PageController: TNotebook;
		Label1: TLabel;
		Label2: TLabel;
		Label3: TLabel;
		URLLabel1: TURLLabel;
		Label4: TLabel;
		DirectoryBox: TDirectoryListBox;
		DriveBox: TDriveComboBox;
		NewFolderButton: TButton;
		Label5: TLabel;
		ProgramGroupBox: TComboBox;
		Label9: TLabel;
		PathLineLabel: TLabel;
		Label11: TLabel;
		PathLineCheckBox: TCheckBox;
		Label6: TLabel;
		FolderLabelTag: TLabel;
		FolderLabel: TLabel;
		ProgramGroupLabelTag: TLabel;
		ProgramGroupLabel: TLabel;
		AddLineLabelTag: TLabel;
		AddLineLabel: TLabel;
		Label14: TLabel;
		Label15: TLabel;
		URLLabel2: TURLLabel;
		URLLabel3: TURLLabel;
		Label16: TLabel;
		URLLabel4: TURLLabel;
		URLLabel5: TURLLabel;
		Label17: TLabel;
		InstallIDECheckBox: TCheckBox;
		InstallTIGCCCheckBox: TCheckBox;
		InstallAppsLabelTag: TLabel;
		InstallAppsLabel: TLabel;
		Label7: TLabel;
		Label8: TLabel;
		InstallExamplesCheckBox: TCheckBox;
		Label12: TLabel;
		LicenseMemo: TMemoComponent;
		LicenseAcceptCheckBox: TCheckBox;
		PrintLicenseButton: TButton;
		Label18: TLabel;
		InstallA68kCheckBox: TCheckBox;
		Label19: TLabel;
		InstallPackCheckBox: TCheckBox;
		Label20: TLabel;
		Label21: TLabel;
		ReadA68kLicenseButton: TButton;
		ReadPackLicenseButton: TButton;
		ReadLicenseButton: TButton;
		SetupImage: TImage;
    Label22: TLabel;
		RegPathLineLabel: TLabel;
    Label25: TLabel;
    RegPathLineCheckBox: TCheckBox;
    NoSystemFolderUseCheckBox: TCheckBox;
		procedure NextButtonClick(Sender: TObject);
		procedure BackButtonClick(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure CancelButtonClick(Sender: TObject);
		procedure PageControllerPageChanged(Sender: TObject);
		procedure NewFolderButtonClick(Sender: TObject);
		procedure ProgramGroupBoxKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure PrintLicenseButtonClick(Sender: TObject);
		procedure ReadLicenseButtonClick(Sender: TObject);
		procedure ReadA68kLicenseButtonClick(Sender: TObject);
		procedure ReadPackLicenseButtonClick(Sender: TObject);
	private
	public
		function GetNextPage(FlipDir: Integer): Integer;
	end;

implementation

{$R *.DFM}

uses
	Registry,
	UtilsDos,
	InstallUnit, NewFolderUnit, LicenseUnit;

{ TMainForm }

function TWizardForm.GetNextPage(FlipDir: Integer): Integer;
var
	FlipAgain: Boolean;
begin
	Result := PageController.PageIndex;
	repeat
		FlipAgain := False;
		Inc (Result, FlipDir);
		if (Result < 0) or (Result >= PageController.Pages.Count) then begin
			Result := -1;
			Exit;
		end;
		if (Result = HTMLHelpDownloadPage) and FileExists (WithBackslash (WinDir) + 'HH.exe') then
			FlipAgain := True;
		if (Result = PathLinePage) and SystemNT then
			FlipAgain := True;
		if (Result = RegPathLinePage) and (not SystemNT) then
			FlipAgain := True;
		if (Result in [PathLinePage, RegPathLinePage]) and not InstallTIGCCCheckBox.Checked then
			FlipAgain := True;
	until not FlipAgain;
end;

procedure TWizardForm.NextButtonClick(Sender: TObject);
var
	NewPage: Integer;
	TmpDir: string;
	F: TSearchRec;
	S: string;
begin
	case PageController.PageIndex of
		FolderSelectionPage: begin
			InstallDir := DirectoryBox.Directory;
			DosFold := '';
			TmpDir := WithBackslash (DirectoryBox.Directory);
			Delete (TmpDir, Length (TmpDir), 1);
			while Length (TmpDir) > 2 do begin
				if FindFirst (TmpDir, faDirectory or faReadOnly or faHidden or faSysFile or faArchive, F) = 0 then begin
					if StrLen (F.FindData.cAlternateFileName) > 0 then
						DosFold := UpperCase (F.FindData.cAlternateFileName) + '\' + DosFold
					else
						DosFold := UpperCase (F.Name) + '\' + DosFold;
				end else
					DosFold := UpperCase (ExtractFileName (TmpDir)) + '\' + DosFold;
				FindClose (F);
				Delete (TmpDir, LastPos ('\', TmpDir), Length (TmpDir));
			end;
			DosFold := UpperCase (TmpDir) + '\' + DosFold;
			if Length (DosFold) > 3 then
				Delete (DosFold, Length (DosFold), 1);
		end;
	end;
	NewPage := GetNextPage (1);
	case NewPage of
		LicensePage:
			LicenseMemo.VisibleRange.RStart := 1;
		FolderSelectionPage: try
			DirectoryBox.Directory := InstallDir;
		except end;
		StartMenuFolderPage: begin
			with TFileReferences.Create do try
				SearchForDirs (ProgPath, atStd);
				ProgramGroupBox.Items.Clear;
				CopyToStrings (ProgramGroupBox.Items);
			finally
				Free;
			end;
		end;
		PathLinePage:
			PathLineLabel.Caption := 'SET PATH=%PATH%;' + DosFold;
		RegPathLinePage:
			RegPathLineLabel.Caption := DosFold;
		ReviseSettingsPage: begin
			S := '';
			if InstallIDECheckBox.Checked then
				S := S + 'IDE; ';
			if InstallTIGCCCheckBox.Checked then
				S := S + 'Command Line Compiler; ';
			if InstallExamplesCheckBox.Checked then
				S := S + 'Examples; ';
			if InstallA68kCheckBox.Checked then
				S := S + 'A68k; ';
			if InstallPackCheckBox.Checked then
				S := S + 'Compression; ';
			InstallAppsLabel.Caption := Copy (S, 1, Length (S) - 2);
			ProgramGroupLabel.Caption := ProgramGroupBox.Text;
			if SystemNT then
				AddLineLabelTag.Caption := 'Add TIGCC to PATH variable:';
			AddLineLabel.Visible := InstallTIGCCCheckBox.Checked;
			AddLineLabelTag.Visible := AddLineLabel.Visible;
			if InstallTIGCCCheckBox.Checked and ((SystemNT and RegPathLineCheckBox.Checked) or ((not SystemNT) and PathLineCheckBox.Checked)) then
				AddLineLabel.Caption := 'Yes'
			else
				AddLineLabel.Caption := 'No';
		end;
	end;
	if NewPage < 0 then
		ModalResult := mrOK
	else
		PageController.PageIndex := NewPage;
end;

procedure TWizardForm.BackButtonClick(Sender: TObject);
var
	NewPage: Integer;
begin
	NewPage := GetNextPage (-1);
	if NewPage >= 0 then
		PageController.PageIndex := NewPage;
end;

procedure TWizardForm.FormCreate(Sender: TObject);
var
	SystemDir: array [0..MAX_PATH] of Char;
	Version: TOSVersionInfo;
begin
	ProgramFilesDir := 'C:\Program Files';
	with TRegistry.Create do try
		RootKey := HKey_Local_Machine;
		if OpenKeyReadOnly ('\Software\Microsoft\Windows\CurrentVersion') then try
			if ValueExists ('ProgramFilesDir') then
				ProgramFilesDir := ReadString ('ProgramFilesDir');
		except end;
		InstallDir := ProgramFilesDir;
		RootKey := HKey_Current_User;
		if OpenKeyReadOnly ('\Software\SeReSoft\TI-GCC IDE') then try
			if ValueExists ('Program Folder') then begin
				InstallDir := ReadString ('Program Folder');
				InstalledBefore := True;
			end;
			if ValueExists ('Program Group') then
				ProgramGroupBox.Text := ReadString ('Program Group');
		except end;
		RootKey := HKey_Local_Machine;
		if OpenKeyReadOnly ('\Software\TIGCC Team\TIGCC') then try
			if ValueExists ('Program Folder') then begin
				InstallDir := ReadString ('Program Folder');
				InstalledBefore := True;
			end;
			if ValueExists ('Program Group') then
				ProgramGroupBox.Text := ReadString ('Program Group');
		except end;
	finally
		Free;
	end;
	GetWindowsDirectory (SystemDir, MAX_PATH);
	WinDir := StrPas (SystemDir);
	GetSystemDirectory (SystemDir, MAX_PATH);
	SysDir := StrPas (SystemDir);
	FillChar (Version, SizeOf (Version), 0);
	Version.dwOSVersionInfoSize := SizeOf (Version);
	GetVersionEx (Version);
	SystemNT := Version.dwPlatformID = VER_PLATFORM_WIN32_NT;
	if InstalledBefore then try
		InstallExamplesCheckBox.Checked := DirExists (WithBackslash (InstallDir) + ExamplesLocation);
		InstallTIGCCCheckBox.Checked := FileExists (WithBackslash (InstallDir) + XaviersTIGCCLocation);
		InstallIDECheckBox.Checked := FileExists (WithBackslash (InstallDir) + IDELocation);
		InstallA68kCheckBox.Checked := FileExists (WithBackslash (InstallDir) + A68kLocation);
		InstallPackCheckBox.Checked := FileExists (WithBackslash (InstallDir) + PackLocation);
	except end;
	PageController.PageIndex := 0;
	ActiveControl := PageController;
end;

procedure TWizardForm.CancelButtonClick(Sender: TObject);
begin
	Close;
end;

procedure TWizardForm.PageControllerPageChanged(Sender: TObject);
begin
	with PageController do begin
		BackButton.Enabled := GetNextPage (-1) >= 0;
		case PageIndex of
			LicensePage:
				NextButton.Enabled := LicenseAcceptCheckBox.Checked;
			InstallAppsPage:
				NextButton.Enabled := InstallIDECheckBox.Checked or InstallTIGCCCheckBox.Checked;
			FolderSelectionPage:
				NextButton.Enabled := ((WithBackslash (UpperCase (DirectoryBox.Directory)) <> 'C:\') and (WithBackslash (UpperCase (DirectoryBox.Directory)) <> WithBackslash (UpperCase (ProgramFilesDir)))) or InstalledBefore;
			StartMenuFolderPage:
				NextButton.Enabled := Length (ProgramGroupBox.Text) > 0;
			else
				NextButton.Enabled := True;
		end;
		if GetNextPage (1) < 0 then
			NextButton.Caption := '&Finish'
		else
			NextButton.Caption := '&Next >';
	end;
end;

procedure TWizardForm.NewFolderButtonClick(Sender: TObject);
var
	Fold: string;
begin
	with TNewFolderForm.Create (Self) do try
		if ShowModal = mrOK then try
			Fold := WithBackslash (DirectoryBox.Directory) + InputBox.Text;
			MkDir (Fold);
			DirectoryBox.Update;
			DirectoryBox.Directory := Fold;
		except end;
	finally
		Free;
	end;
end;

procedure TWizardForm.ProgramGroupBoxKeyDown(Sender: TObject; var Key: Word;
	Shift: TShiftState);
begin
	if (Key = vk_Return) and NextButton.Enabled then
		NextButton.Click;
	if Key = vk_Cancel then
		Close;
end;

procedure TWizardForm.PrintLicenseButtonClick(Sender: TObject);
var
	F: System.Text;
begin
	try
		AssignFile (F, 'LPT1:');
		ReWrite (F);
		WriteLn (F, LicenseMemo.Text);
		Write (F, #12);
		CloseFile (F);
	except
		Application.MessageBox ('An error occured while trying to print the document.', 'Error', mb_OK or mb_IconError);
	end;
end;

procedure TWizardForm.ReadLicenseButtonClick(Sender: TObject);
begin
	with TLicenseForm.Create (Self) do try
		ClientWidth := 592;
		ClientHeight := 373;
		LicenseMemo.Text := Self.LicenseMemo.Text;
		ShowModal;
	finally
		Free;
	end;
end;

procedure TWizardForm.ReadA68kLicenseButtonClick(Sender: TObject);
begin
	with TLicenseForm.Create (Self) do try
		ClientWidth := 396;
		ClientHeight := 123;
		LicenseMemo.Text := 'This program is Freely Distributable, as opposed to'#13#10
			+ 'Public Domain.'#13#10
			+ 'Permission is given to freely distribute this program'#13#10
			+ 'provided no fee is charged, and the documentation'#13#10
			+ 'file is included with the program.'#13#10#13#10
			+ '(The original text said "this documentation" instead'#13#10
			+ 'of "the documentation.")';
		ShowModal;
	finally
		Free;
	end;
end;

procedure TWizardForm.ReadPackLicenseButtonClick(Sender: TObject);
begin
	with TLicenseForm.Create (Self) do try
		ClientWidth := 496;
		ClientHeight := 233;
		LicenseMemo.Text := '(This license applies to the TIGCC Tools Suite, which the ExePack'#13#10
			+ 'System originates from.)'#13#10#13#10
			+ 'The Tools in this release may be distributed by any other website'#13#10
			+ 'for non-commercial use only.'#13#10#13#10
			+ 'The author makes no representations or warranties about the'#13#10
			+ 'suitability of the software, either express or implied. The'#13#10
			+ 'author shall not be liable for any damages suffered as a result of'#13#10
			+ 'using or distributing this software.'#13#10#13#10
			+ 'IF YOU USE or RE-USE any PART of this SUITE, PLEASE GIVE CREDITS to'#13#10
			+ 'US INCLUDING a LINK to our WEBSITE (http://tict.ticalc.org)'#13#10#13#10
			+ '("Any other website" probably refers to any website other than'#13#10
			+ 'http://tict.ticalc.org.)';
		ShowModal;
	finally
		Free;
	end;
end;

end.
